/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 661
#ifdef HAVE_CONFIG_H
#line 661
# include <config.h>
#line 661
#endif
#line 661
#include <sys/types.h>
#line 661

#line 661
#include "mailfromd.h"
#line 661
#include "prog.h"
#line 661
#include "builtin.h"
#line 661

#line 661

#line 769 "../../src/builtin/snarf.m4"

#line 1 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"
#include "global.h"

static size_t nmsgs = MAX_MSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_cfg_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return xcalloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 57

#line 57
static int MSGTAB_id;
#line 57 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		mu_stream_destroy(&mp->mstr);
		mu_stream_destroy(&mp->bstr);
		if (mp->type == MF_MSG_STANDALONE)
			mu_message_destroy(&mp->msg,
					   mu_message_get_owner(mp->msg));
		mu_list_foreach(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int type)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->type = type;
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT)
			return i;
	return -1;
}


#line 132


#line 143


#line 154


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 159
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 159
	struct mf_message *mp;
#line 159
			
#line 159
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 159
		(
#line 159
	env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 159
)
#line 159
;
#line 159
	mp = mtab + nmsg;
#line 159
		if (!(mp->msg))
#line 159
		(
#line 159
	env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 159
)
#line 159

#line 159
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 164
bi_message_close(eval_environ_t env)
#line 164

#line 164

#line 164 "msg.bi"
{
#line 164
	
#line 164

#line 164

#line 164
long  nmsg;
#line 164
        
#line 164
get_numeric_arg(env, 0, &nmsg);
#line 164
        
#line 164

#line 164
        adjust_stack(env, 1);
#line 164

#line 164

#line 164
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 164
		prog_trace(env, "message_close %lu",nmsg);;
#line 164

{
	
#line 166
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 166
	struct mf_message *mp;
#line 166
			
#line 166
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 166
		(
#line 166
	env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 166
)
#line 166
;
#line 166
	mp = mtab + nmsg;
#line 166
		if (!(mp->msg))
#line 166
		(
#line 166
	env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 166
)
#line 166

#line 166
;
	bi_close_message(mp);
}

#line 169
        env_function_cleanup_flush(env, NULL);
#line 169
	return;
#line 169
}

/* number message_size(number nmsg) */
void
#line 172
bi_message_size(eval_environ_t env)
#line 172

#line 172

#line 172 "msg.bi"
{
#line 172
	
#line 172

#line 172

#line 172
long  nmsg;
#line 172
        
#line 172
get_numeric_arg(env, 0, &nmsg);
#line 172
        
#line 172

#line 172
        adjust_stack(env, 1);
#line 172

#line 172

#line 172
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 172
		prog_trace(env, "message_size %lu",nmsg);;
#line 172

{
	int rc;
	size_t size;
	
#line 176
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 176
	struct mf_message *mp;
#line 176
			
#line 176
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 176
		(
#line 176
	env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 176
)
#line 176
;
#line 176
	mp = mtab + nmsg;
#line 176
		if (!(mp->msg))
#line 176
		(
#line 176
	env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 176
)
#line 176

#line 176
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 179
		(
#line 179
	env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 179
)
#line 181
;
		if (!(size < LONG_MAX))
#line 182
		(
#line 182
	env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 182
)
#line 184
;
	
#line 185
do {
#line 185
  push(env, (STKVAL) ((long)size));
#line 185
  goto endlab;
#line 185
} while (0);
}	
endlab:
#line 187
        env_function_cleanup_flush(env, NULL);
#line 187
	return;
#line 187
}

/* number message_lines(number nmsg) */
void
#line 190
bi_message_lines(eval_environ_t env)
#line 190

#line 190

#line 190 "msg.bi"
{
#line 190
	
#line 190

#line 190

#line 190
long  nmsg;
#line 190
        
#line 190
get_numeric_arg(env, 0, &nmsg);
#line 190
        
#line 190

#line 190
        adjust_stack(env, 1);
#line 190

#line 190

#line 190
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 190
		prog_trace(env, "message_lines %lu",nmsg);;
#line 190

{
	int rc;
	size_t lines;
	
#line 194
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 194
	struct mf_message *mp;
#line 194
			
#line 194
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 194
		(
#line 194
	env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 194
)
#line 194
;
#line 194
	mp = mtab + nmsg;
#line 194
		if (!(mp->msg))
#line 194
		(
#line 194
	env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 194
)
#line 194

#line 194
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 197
		(
#line 197
	env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 197
)
#line 200
;
	
#line 201
do {
#line 201
  push(env, (STKVAL) (lines));
#line 201
  goto endlab;
#line 201
} while (0);
}
endlab:
#line 203
        env_function_cleanup_flush(env, NULL);
#line 203
	return;
#line 203
}

/* number message_body_size(number nmsg) */
void
#line 206
bi_message_body_size(eval_environ_t env)
#line 206

#line 206

#line 206 "msg.bi"
{
#line 206
	
#line 206

#line 206

#line 206
long  nmsg;
#line 206
        
#line 206
get_numeric_arg(env, 0, &nmsg);
#line 206
        
#line 206

#line 206
        adjust_stack(env, 1);
#line 206

#line 206

#line 206
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 206
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 206

{
	int rc;
	size_t size;
	
#line 210
	
#line 210
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 210
	struct mf_message *mp;
#line 210
			
#line 210
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 210
		(
#line 210
	env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 210
)
#line 210
;
#line 210
	mp = mtab + nmsg;
#line 210
		if (!(mp->msg))
#line 210
		(
#line 210
	env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 210
)
#line 210

#line 210
;
#line 210
	if (!mp->body) {
#line 210
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 210
			if (!(rc == 0))
#line 210
		(
#line 210
	env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 210
)
#line 210
;
#line 210
	}	  
#line 210
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 213
		(
#line 213
	env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 213
)
#line 215
;
		if (!(size < LONG_MAX))
#line 216
		(
#line 216
	env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 216
)
#line 218
;
	
#line 219
do {
#line 219
  push(env, (STKVAL) ((long)size));
#line 219
  goto endlab;
#line 219
} while (0);
}
endlab:
#line 221
        env_function_cleanup_flush(env, NULL);
#line 221
	return;
#line 221
}

/* number message_body_lines(number nmsg) */
void
#line 224
bi_message_body_lines(eval_environ_t env)
#line 224

#line 224

#line 224 "msg.bi"
{
#line 224
	
#line 224

#line 224

#line 224
long  nmsg;
#line 224
        
#line 224
get_numeric_arg(env, 0, &nmsg);
#line 224
        
#line 224

#line 224
        adjust_stack(env, 1);
#line 224

#line 224

#line 224
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 224
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 224

{
	int rc;
	size_t lines;
	
#line 228
	
#line 228
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 228
	struct mf_message *mp;
#line 228
			
#line 228
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 228
)
#line 228
;
#line 228
	mp = mtab + nmsg;
#line 228
		if (!(mp->msg))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 228
)
#line 228

#line 228
;
#line 228
	if (!mp->body) {
#line 228
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 228
			if (!(rc == 0))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 228
)
#line 228
;
#line 228
	}	  
#line 228
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 231
		(
#line 231
	env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 231
)
#line 234
;
	
#line 235
do {
#line 235
  push(env, (STKVAL) (lines));
#line 235
  goto endlab;
#line 235
} while (0);
}
endlab:
#line 237
        env_function_cleanup_flush(env, NULL);
#line 237
	return;
#line 237
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 243
bi_message_header_size(eval_environ_t env)
#line 243

#line 243

#line 243 "msg.bi"
{
#line 243
	
#line 243

#line 243

#line 243
long  nmsg;
#line 243
        
#line 243
get_numeric_arg(env, 0, &nmsg);
#line 243
        
#line 243

#line 243
        adjust_stack(env, 1);
#line 243

#line 243

#line 243
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 243
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 243

{
	int rc;
	size_t size;
	
#line 247
	
#line 247
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 247
	struct mf_message *mp;
#line 247
			
#line 247
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 247
		(
#line 247
	env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 247
)
#line 247
;
#line 247
	mp = mtab + nmsg;
#line 247
		if (!(mp->msg))
#line 247
		(
#line 247
	env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 247
)
#line 247

#line 247
;
#line 247
	if (!mp->hdr) {
#line 247
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 247
			if (!(rc == 0))
#line 247
		(
#line 247
	env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 247
)
#line 247
;
#line 247
	}	  
#line 247
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 250
		(
#line 250
	env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 250
)
#line 252
;
		if (!(size < LONG_MAX))
#line 253
		(
#line 253
	env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 253
)
#line 255
;
	
#line 256
do {
#line 256
  push(env, (STKVAL) ((long)size));
#line 256
  goto endlab;
#line 256
} while (0);
}
endlab:
#line 258
        env_function_cleanup_flush(env, NULL);
#line 258
	return;
#line 258
}

/* number message_header_lines(number nmsg) */
void
#line 261
bi_message_header_lines(eval_environ_t env)
#line 261

#line 261

#line 261 "msg.bi"
{
#line 261
	
#line 261

#line 261

#line 261
long  nmsg;
#line 261
        
#line 261
get_numeric_arg(env, 0, &nmsg);
#line 261
        
#line 261

#line 261
        adjust_stack(env, 1);
#line 261

#line 261

#line 261
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 261
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 261

{
	int rc;
	size_t lines;
	
#line 265
	
#line 265
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 265
	struct mf_message *mp;
#line 265
			
#line 265
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 265
		(
#line 265
	env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 265
)
#line 265
;
#line 265
	mp = mtab + nmsg;
#line 265
		if (!(mp->msg))
#line 265
		(
#line 265
	env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 265
)
#line 265

#line 265
;
#line 265
	if (!mp->hdr) {
#line 265
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 265
			if (!(rc == 0))
#line 265
		(
#line 265
	env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 265
)
#line 265
;
#line 265
	}	  
#line 265
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 268
		(
#line 268
	env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 268
)
#line 271
;
	
#line 272
do {
#line 272
  push(env, (STKVAL) (lines));
#line 272
  goto endlab;
#line 272
} while (0);
}
endlab:
#line 274
        env_function_cleanup_flush(env, NULL);
#line 274
	return;
#line 274
}

/* number message_header_count(number nmsg[; string name]) */
void
#line 277
bi_message_header_count(eval_environ_t env)
#line 277

#line 277

#line 277 "msg.bi"
{
#line 277
	
#line 277

#line 277
long __bi_argcnt;
#line 277
long  nmsg;
#line 277
        char *  name;
#line 277
        
#line 277
get_numeric_arg(env, 1, &nmsg);
#line 277
        get_string_arg(env, 2, &name);
#line 277
        
#line 277
get_numeric_arg(env, 0, &__bi_argcnt);
#line 277
        adjust_stack(env, __bi_argcnt + 1);
#line 277

#line 277

#line 277
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 277
		prog_trace(env, "message_header_count %lu %s",nmsg, ((__bi_argcnt > 1) ? name : ""));;

{
	int rc;
	size_t count;
	
#line 282
	
#line 282
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 282
	struct mf_message *mp;
#line 282
			
#line 282
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 282
		(
#line 282
	env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 282
)
#line 282
;
#line 282
	mp = mtab + nmsg;
#line 282
		if (!(mp->msg))
#line 282
		(
#line 282
	env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 282
)
#line 282

#line 282
;
#line 282
	if (!mp->hdr) {
#line 282
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 282
			if (!(rc == 0))
#line 282
		(
#line 282
	env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 282
)
#line 282
;
#line 282
	}	  
#line 282
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 285
		(
#line 285
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 285
)
#line 288
;
	
	if ((__bi_argcnt > 1)) {
		size_t n;

		for (n = 1; n <= count; n++) {
			const char *val;
			rc = mu_header_sget_value_n(mp->hdr, name, n, &val);
			if (rc == MU_ERR_NOENT)
				break;
			else if (rc)
				(
#line 299
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 299
);
		}
		count = n - 1;
	}
	
#line 303
do {
#line 303
  push(env, (STKVAL) (count));
#line 303
  goto endlab;
#line 303
} while (0);
}
endlab:
#line 305
        env_function_cleanup_flush(env, NULL);
#line 305
	return;
#line 305
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 308
bi_message_has_header(eval_environ_t env)
#line 308

#line 308

#line 308 "msg.bi"
{
#line 308
	
#line 308

#line 308
long __bi_argcnt;
#line 308
long  nmsg;
#line 308
        char *  header;
#line 308
        long  idx;
#line 308
        
#line 308
get_numeric_arg(env, 1, &nmsg);
#line 308
        get_string_arg(env, 2, &header);
#line 308
        get_numeric_arg(env, 3, &idx);
#line 308
        
#line 308
get_numeric_arg(env, 0, &__bi_argcnt);
#line 308
        adjust_stack(env, __bi_argcnt + 1);
#line 308

#line 308

#line 308
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 308
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 313
	
#line 313
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 313
	struct mf_message *mp;
#line 313
			
#line 313
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 313
		(
#line 313
	env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 313
)
#line 313
;
#line 313
	mp = mtab + nmsg;
#line 313
		if (!(mp->msg))
#line 313
		(
#line 313
	env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 313
)
#line 313

#line 313
;
#line 313
	if (!mp->hdr) {
#line 313
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 313
			if (!(rc == 0))
#line 313
		(
#line 313
	env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 313
)
#line 313
;
#line 313
	}	  
#line 313
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 316
do {
#line 316
  push(env, (STKVAL) (rc == 0));
#line 316
  goto endlab;
#line 316
} while (0);
}
endlab:
#line 318
        env_function_cleanup_flush(env, NULL);
#line 318
	return;
#line 318
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 321
bi_message_find_header(eval_environ_t env)
#line 321

#line 321

#line 321 "msg.bi"
{
#line 321
	
#line 321

#line 321
long __bi_argcnt;
#line 321
long  nmsg;
#line 321
        char * MFL_DATASEG header;
#line 321
        long  idx;
#line 321
        
#line 321
get_numeric_arg(env, 1, &nmsg);
#line 321
        get_string_arg(env, 2, &header);
#line 321
        get_numeric_arg(env, 3, &idx);
#line 321
        
#line 321
get_numeric_arg(env, 0, &__bi_argcnt);
#line 321
        adjust_stack(env, __bi_argcnt + 1);
#line 321

#line 321

#line 321
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 321
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 326
	
#line 326
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 326
	struct mf_message *mp;
#line 326
			
#line 326
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 326
		(
#line 326
	env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 326
)
#line 326
;
#line 326
	mp = mtab + nmsg;
#line 326
		if (!(mp->msg))
#line 326
		(
#line 326
	env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 326
)
#line 326

#line 326
;
#line 326
	if (!mp->hdr) {
#line 326
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 326
			if (!(rc == 0))
#line 326
		(
#line 326
	env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 326
)
#line 326
;
#line 326
	}	  
#line 326
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
		(
#line 330
	env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"))
#line 330
);
	else if (rc)
		(
#line 332
	env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc))
#line 332
);
	do {pushs(env, val);
#line 333
goto endlab;
#line 333
} while (0);
}
endlab:
#line 335
        env_function_cleanup_flush(env, NULL);
#line 335
	return;
#line 335
}

/* string message_nth_header_name(number msg, number n) */
void
#line 338
bi_message_nth_header_name(eval_environ_t env)
#line 338

#line 338

#line 338 "msg.bi"
{
#line 338
	
#line 338

#line 338

#line 338
long  nmsg;
#line 338
        long  idx;
#line 338
        
#line 338
get_numeric_arg(env, 0, &nmsg);
#line 338
        get_numeric_arg(env, 1, &idx);
#line 338
        
#line 338

#line 338
        adjust_stack(env, 2);
#line 338

#line 338

#line 338
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 338
		prog_trace(env, "message_nth_header_name %lu %lu",nmsg, idx);;
#line 338

{
	int rc;
	const char *val;
	
#line 342
	
#line 342
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 342
	struct mf_message *mp;
#line 342
			
#line 342
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 342
		(
#line 342
	env_throw_bi(env, mfe_range, "message_nth_header_name", _("invalid message descriptor"))
#line 342
)
#line 342
;
#line 342
	mp = mtab + nmsg;
#line 342
		if (!(mp->msg))
#line 342
		(
#line 342
	env_throw_bi(env, mfe_failure, "message_nth_header_name", _("message not open"))
#line 342
)
#line 342

#line 342
;
#line 342
	if (!mp->hdr) {
#line 342
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 342
			if (!(rc == 0))
#line 342
		(
#line 342
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "mu_message_get_header: %s",mu_strerror(rc))
#line 342
)
#line 342
;
#line 342
	}	  
#line 342
;
	
	rc = mu_header_sget_field_name(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 346
	env_throw_bi(env, mfe_range, "message_nth_header_name", "header index out of range")
#line 346
);
	else if (rc)
		(
#line 348
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "%s",mu_strerror(rc))
#line 348
);
	do {pushs(env, val);
#line 349
goto endlab;
#line 349
} while (0);
}
endlab:
#line 351
        env_function_cleanup_flush(env, NULL);
#line 351
	return;
#line 351
}

/* string message_nth_header_value(number msg, number n) */
void
#line 354
bi_message_nth_header_value(eval_environ_t env)
#line 354

#line 354

#line 354 "msg.bi"
{
#line 354
	
#line 354

#line 354

#line 354
long  nmsg;
#line 354
        long  idx;
#line 354
        
#line 354
get_numeric_arg(env, 0, &nmsg);
#line 354
        get_numeric_arg(env, 1, &idx);
#line 354
        
#line 354

#line 354
        adjust_stack(env, 2);
#line 354

#line 354

#line 354
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 354
		prog_trace(env, "message_nth_header_value %lu %lu",nmsg, idx);;
#line 354

{
	int rc;
	const char *val;
	
#line 358
	
#line 358
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 358
	struct mf_message *mp;
#line 358
			
#line 358
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 358
		(
#line 358
	env_throw_bi(env, mfe_range, "message_nth_header_value", _("invalid message descriptor"))
#line 358
)
#line 358
;
#line 358
	mp = mtab + nmsg;
#line 358
		if (!(mp->msg))
#line 358
		(
#line 358
	env_throw_bi(env, mfe_failure, "message_nth_header_value", _("message not open"))
#line 358
)
#line 358

#line 358
;
#line 358
	if (!mp->hdr) {
#line 358
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 358
			if (!(rc == 0))
#line 358
		(
#line 358
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "mu_message_get_header: %s",mu_strerror(rc))
#line 358
)
#line 358
;
#line 358
	}	  
#line 358
;
	
	rc = mu_header_sget_field_value(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 362
	env_throw_bi(env, mfe_range, "message_nth_header_value", "header index out of range")
#line 362
);
	else if (rc)
		(
#line 364
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "%s",mu_strerror(rc))
#line 364
);
	do {pushs(env, val);
#line 365
goto endlab;
#line 365
} while (0);
}
endlab:
#line 367
        env_function_cleanup_flush(env, NULL);
#line 367
	return;
#line 367
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 373
bi_message_is_multipart(eval_environ_t env)
#line 373

#line 373

#line 373 "msg.bi"
{
#line 373
	
#line 373

#line 373

#line 373
long  nmsg;
#line 373
        
#line 373
get_numeric_arg(env, 0, &nmsg);
#line 373
        
#line 373

#line 373
        adjust_stack(env, 1);
#line 373

#line 373

#line 373
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 373
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 373

{
	int rc, res;
	
#line 376
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 376
	struct mf_message *mp;
#line 376
			
#line 376
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 376
		(
#line 376
	env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 376
)
#line 376
;
#line 376
	mp = mtab + nmsg;
#line 376
		if (!(mp->msg))
#line 376
		(
#line 376
	env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 376
)
#line 376

#line 376
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 379
		(
#line 379
	env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 379
)
#line 382
;
	
#line 383
do {
#line 383
  push(env, (STKVAL) (res));
#line 383
  goto endlab;
#line 383
} while (0);
}
endlab:
#line 385
        env_function_cleanup_flush(env, NULL);
#line 385
	return;
#line 385
}

/* number message_count_parts(number msg) */
void
#line 388
bi_message_count_parts(eval_environ_t env)
#line 388

#line 388

#line 388 "msg.bi"
{
#line 388
	
#line 388

#line 388

#line 388
long  nmsg;
#line 388
        
#line 388
get_numeric_arg(env, 0, &nmsg);
#line 388
        
#line 388

#line 388
        adjust_stack(env, 1);
#line 388

#line 388

#line 388
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 388
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 388

{
	int rc;
	size_t count;
	
#line 392
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 392
	struct mf_message *mp;
#line 392
			
#line 392
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 392
		(
#line 392
	env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 392
)
#line 392
;
#line 392
	mp = mtab + nmsg;
#line 392
		if (!(mp->msg))
#line 392
		(
#line 392
	env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 392
)
#line 392

#line 392
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 394
		(
#line 394
	env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 394
)
#line 397
;
	
#line 398
do {
#line 398
  push(env, (STKVAL) (count));
#line 398
  goto endlab;
#line 398
} while (0);
}
endlab:
#line 400
        env_function_cleanup_flush(env, NULL);
#line 400
	return;
#line 400
}

/* number message_get_part(number msg, number idx) */
void
#line 403
bi_message_get_part(eval_environ_t env)
#line 403

#line 403

#line 403 "msg.bi"
{
#line 403
	
#line 403

#line 403

#line 403
long  nmsg;
#line 403
        long  idx;
#line 403
        
#line 403
get_numeric_arg(env, 0, &nmsg);
#line 403
        get_numeric_arg(env, 1, &idx);
#line 403
        
#line 403

#line 403
        adjust_stack(env, 2);
#line 403

#line 403

#line 403
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 403
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 403

{
	int rc;
	mu_message_t msg;
	
#line 407
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 407
	struct mf_message *mp;
#line 407
			
#line 407
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 407
		(
#line 407
	env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 407
)
#line 407
;
#line 407
	mp = mtab + nmsg;
#line 407
		if (!(mp->msg))
#line 407
		(
#line 407
	env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 407
)
#line 407

#line 407
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 410
		(
#line 410
	env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 410
)
#line 413
;
	rc = bi_message_register(env, mp->msglist, msg, MF_MSG_MAILBOX);
		if (!(rc >= 0))
#line 415
		(
#line 415
	env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 415
)
#line 417
;
	
#line 418
do {
#line 418
  push(env, (STKVAL) (rc));
#line 418
  goto endlab;
#line 418
} while (0);
}
endlab:
#line 420
        env_function_cleanup_flush(env, NULL);
#line 420
	return;
#line 420
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 426
bi_message_rewind(eval_environ_t env)
#line 426

#line 426

#line 426 "msg.bi"
{
#line 426
	
#line 426

#line 426

#line 426
long  nmsg;
#line 426
        
#line 426
get_numeric_arg(env, 0, &nmsg);
#line 426
        
#line 426

#line 426
        adjust_stack(env, 1);
#line 426

#line 426

#line 426
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 426
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 426

{
	
#line 428
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 428
	struct mf_message *mp;
#line 428
			
#line 428
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 428
		(
#line 428
	env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 428
)
#line 428
;
#line 428
	mp = mtab + nmsg;
#line 428
		if (!(mp->msg))
#line 428
		(
#line 428
	env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 428
)
#line 428

#line 428
;
	mu_stream_destroy(&mp->mstr);
}

#line 431
        env_function_cleanup_flush(env, NULL);
#line 431
	return;
#line 431
}

/* string message_read_line(number nmsg) */
void
#line 434
bi_message_read_line(eval_environ_t env)
#line 434

#line 434

#line 434 "msg.bi"
{
#line 434
	
#line 434

#line 434

#line 434
long  nmsg;
#line 434
        
#line 434
get_numeric_arg(env, 0, &nmsg);
#line 434
        
#line 434

#line 434
        adjust_stack(env, 1);
#line 434

#line 434

#line 434
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 434
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 434

{
	int rc;
	size_t size;
	
#line 438
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 438
	struct mf_message *mp;
#line 438
			
#line 438
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 438
		(
#line 438
	env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 438
)
#line 438
;
#line 438
	mp = mtab + nmsg;
#line 438
		if (!(mp->msg))
#line 438
		(
#line 438
	env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 438
)
#line 438

#line 438
;

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 442
		(
#line 442
	env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 442
)
#line 445
;
	}
	rc = mu_stream_getline(mp->mstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 448
		(
#line 448
	env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 448
)
#line 451
;
		if (!(size > 0))
#line 452
		(
#line 452
	env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_getline: %s",_("end of input"))
#line 452
)
#line 455
;
	do {pushs(env, mp->buf);
#line 456
goto endlab;
#line 456
} while (0);
}
endlab:
#line 458
        env_function_cleanup_flush(env, NULL);
#line 458
	return;
#line 458
}

/* string message_body_rewind(number nmsg) */
void
#line 461
bi_message_body_rewind(eval_environ_t env)
#line 461

#line 461

#line 461 "msg.bi"
{
#line 461
	
#line 461

#line 461

#line 461
long  nmsg;
#line 461
        
#line 461
get_numeric_arg(env, 0, &nmsg);
#line 461
        
#line 461

#line 461
        adjust_stack(env, 1);
#line 461

#line 461

#line 461
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 461
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 461

{
	
#line 463
	
#line 463
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 463
	struct mf_message *mp;
#line 463
			
#line 463
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 463
)
#line 463
;
#line 463
	mp = mtab + nmsg;
#line 463
		if (!(mp->msg))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 463
)
#line 463

#line 463
;
#line 463
	if (!mp->body) {
#line 463
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 463
			if (!(rc == 0))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 463
)
#line 463
;
#line 463
	}	  
#line 463
;
	mu_stream_destroy(&mp->bstr);
}

#line 466
        env_function_cleanup_flush(env, NULL);
#line 466
	return;
#line 466
}

/* string message_read_body_line(number msg)  */
void
#line 469
bi_message_read_body_line(eval_environ_t env)
#line 469

#line 469

#line 469 "msg.bi"
{
#line 469
	
#line 469

#line 469

#line 469
long  nmsg;
#line 469
        
#line 469
get_numeric_arg(env, 0, &nmsg);
#line 469
        
#line 469

#line 469
        adjust_stack(env, 1);
#line 469

#line 469

#line 469
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 469
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 469

{
	int rc;
	size_t size;
	
#line 473
	
#line 473
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 473
	struct mf_message *mp;
#line 473
			
#line 473
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 473
		(
#line 473
	env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 473
)
#line 473
;
#line 473
	mp = mtab + nmsg;
#line 473
		if (!(mp->msg))
#line 473
		(
#line 473
	env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 473
)
#line 473

#line 473
;
#line 473
	if (!mp->body) {
#line 473
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 473
			if (!(rc == 0))
#line 473
		(
#line 473
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 473
)
#line 473
;
#line 473
	}	  
#line 473
;
	
	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 477
		(
#line 477
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 477
)
#line 480
;
	}
	rc = mu_stream_getline(mp->bstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 483
		(
#line 483
	env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 483
)
#line 486
;
		if (!(size > 0))
#line 487
		(
#line 487
	env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_getline: %s",_("end of input"))
#line 487
)
#line 490
;
	do {pushs(env, mp->buf);
#line 491
goto endlab;
#line 491
} while (0);
}
endlab:
#line 493
        env_function_cleanup_flush(env, NULL);
#line 493
	return;
#line 493
}

/* string message_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 496
bi_message_to_stream(eval_environ_t env)
#line 496

#line 496

#line 496 "msg.bi"
{
#line 496
	
#line 496

#line 496
long __bi_argcnt;
#line 496
long  fd;
#line 496
        long  nmsg;
#line 496
        char *  fltchain;
#line 496
        
#line 496
get_numeric_arg(env, 1, &fd);
#line 496
        get_numeric_arg(env, 2, &nmsg);
#line 496
        get_string_arg(env, 3, &fltchain);
#line 496
        
#line 496
get_numeric_arg(env, 0, &__bi_argcnt);
#line 496
        adjust_stack(env, __bi_argcnt + 1);
#line 496

#line 496

#line 496
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 496
		prog_trace(env, "message_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 504
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 504
	struct mf_message *mp;
#line 504
			
#line 504
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 504
		(
#line 504
	env_throw_bi(env, mfe_range, "message_to_stream", _("invalid message descriptor"))
#line 504
)
#line 504
;
#line 504
	mp = mtab + nmsg;
#line 504
		if (!(mp->msg))
#line 504
		(
#line 504
	env_throw_bi(env, mfe_failure, "message_to_stream", _("message not open"))
#line 504
)
#line 504

#line 504
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 508
		(
#line 508
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 508
)
#line 511
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 518
		(
#line 518
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 518
)
#line 521
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 526
		(
#line 526
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 526
)
#line 530
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 537
		(
#line 537
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_message_get_stream: %s",mu_strerror(rc))
#line 537
)
#line 540
;
	}
	rc = mu_stream_copy(dst, mp->mstr, 0, NULL);
		if (!(rc == 0))
#line 543
		(
#line 543
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 543
)
#line 546
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 550
        env_function_cleanup_flush(env, NULL);
#line 550
	return;
#line 550
}

/* number message_from_stream(number fd; string mu_filter_chain) */
void
#line 553
bi_message_from_stream(eval_environ_t env)
#line 553

#line 553

#line 553 "msg.bi"
{
#line 553
	
#line 553

#line 553
long __bi_argcnt;
#line 553
long  fd;
#line 553
        char *  fltchain;
#line 553
        
#line 553
get_numeric_arg(env, 1, &fd);
#line 553
        get_string_arg(env, 2, &fltchain);
#line 553
        
#line 553
get_numeric_arg(env, 0, &__bi_argcnt);
#line 553
        adjust_stack(env, __bi_argcnt + 1);
#line 553

#line 553

#line 553
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 553
		prog_trace(env, "message_from_stream %lu %s",fd, ((__bi_argcnt > 1) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t src;
	char *flts = ((__bi_argcnt > 1) ? fltchain : 0);
	mu_message_t msg;
	
	rc = mu_fd_stream_create(&src, NULL, _bi_io_fd(env, fd, 0),
				 MU_STREAM_READ|MU_STREAM_SEEK);
				    
		if (!(rc == 0))
#line 565
		(
#line 565
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 565
)
#line 568
;
	mu_stream_ioctl(src, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 575
		(
#line 575
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 575
)
#line 578
;
		rc = mu_filter_chain_create(&flt, src, MU_FILTER_ENCODE,
					    MU_STREAM_READ,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 583
		(
#line 583
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 583
)
#line 587
;
		mu_stream_unref(src);
		src = flt;
	}

	msg = _builtin_mu_stream_to_message(src, env, "message_from_stream");

	rc = bi_message_register(env, NULL, msg, MF_MSG_STANDALONE);
	if (rc < 0) {
		mu_message_destroy(&msg, mu_message_get_owner(msg));
		(
#line 597
	env_throw_bi(env, mfe_failure, "message_from_stream", _("no more message slots available"))
#line 597
);
#line 599
	}
	
#line 600
do {
#line 600
  push(env, (STKVAL) (rc));
#line 600
  goto endlab;
#line 600
} while (0);
}
endlab:
#line 602
        env_function_cleanup_flush(env, NULL);
#line 602
	return;
#line 602
}

/* string message_body_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 605
bi_message_body_to_stream(eval_environ_t env)
#line 605

#line 605

#line 605 "msg.bi"
{
#line 605
	
#line 605

#line 605
long __bi_argcnt;
#line 605
long  fd;
#line 605
        long  nmsg;
#line 605
        char *  fltchain;
#line 605
        
#line 605
get_numeric_arg(env, 1, &fd);
#line 605
        get_numeric_arg(env, 2, &nmsg);
#line 605
        get_string_arg(env, 3, &fltchain);
#line 605
        
#line 605
get_numeric_arg(env, 0, &__bi_argcnt);
#line 605
        adjust_stack(env, __bi_argcnt + 1);
#line 605

#line 605

#line 605
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 605
		prog_trace(env, "message_body_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 613
	
#line 613
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 613
	struct mf_message *mp;
#line 613
			
#line 613
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 613
		(
#line 613
	env_throw_bi(env, mfe_range, "message_body_to_stream", _("invalid message descriptor"))
#line 613
)
#line 613
;
#line 613
	mp = mtab + nmsg;
#line 613
		if (!(mp->msg))
#line 613
		(
#line 613
	env_throw_bi(env, mfe_failure, "message_body_to_stream", _("message not open"))
#line 613
)
#line 613

#line 613
;
#line 613
	if (!mp->body) {
#line 613
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 613
			if (!(rc == 0))
#line 613
		(
#line 613
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_message_get_body: %s",mu_strerror(rc))
#line 613
)
#line 613
;
#line 613
	}	  
#line 613
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 617
		(
#line 617
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 617
)
#line 620
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 627
		(
#line 627
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 627
)
#line 630
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 635
		(
#line 635
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 635
)
#line 639
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 646
		(
#line 646
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_body_get_stream: %s",mu_strerror(rc))
#line 646
)
#line 649
;
	}
	rc = mu_stream_copy(dst, mp->bstr, 0, NULL);
		if (!(rc == 0))
#line 652
		(
#line 652
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 652
)
#line 655
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 659
        env_function_cleanup_flush(env, NULL);
#line 659
	return;
#line 659
}


#line 661
void
#line 661
msg_init_builtin()
#line 661
{
#line 661
	
#line 661
	#line 57 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 57
drop_current_message);
#line 164 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 172 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 190 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 206 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 224 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 243 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 261 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 277 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 308 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 321 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 338 "msg.bi"
va_builtin_install_ex("message_nth_header_name", bi_message_nth_header_name, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 354 "msg.bi"
va_builtin_install_ex("message_nth_header_value", bi_message_nth_header_value, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 373 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 388 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 403 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 426 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 434 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 461 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 469 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 496 "msg.bi"
va_builtin_install_ex("message_to_stream", bi_message_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);
#line 553 "msg.bi"
va_builtin_install_ex("message_from_stream", bi_message_from_stream, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 605 "msg.bi"
va_builtin_install_ex("message_body_to_stream", bi_message_body_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);

#line 661 "msg.bi"
	
#line 661
	 mf_add_runtime_params(msg_cfg_param);
#line 661
	 
#line 661
}
#line 661 "msg.bi"

#line 663

#line 763 "../../src/builtin/snarf.m4"

#line 763

